// Written by Dr. YIP Chi Lap [Beta]
//   for Talk on "DIY Ultraviolet Radiation Measurement Device"
//   Ultraviolet Radiation Measurement and Application Design Competition,
//   Faculty of Engineering, The University of Hong Kong, 2017.
//   http://www.cs.hku.hk/~uv/

PImage img;


void setup() {
  /* Initial set up required by processing. */
  size(0, 0);
  surface.setResizable(true);
  
  // load the image
  img = loadImage("After.jpg");

  // make window same size as that of image
  surface.setSize(img.width, img.height);
}


void draw() {
  // use image as background
  background(img);
  loadPixels();
}


/*
  Whenever the mouse is moved,
    the sum of brightness values of all pixels
    on the vertical line the mouse is in is printed.
 */
void mouseMoved() {
  // The sum is initialized to zero for accumulation of brightness values
  int sum = 0;
  // Since we are examining all pixels in the image,
  //   so we loop from 0 to the full height of the image.
  for (int y=0; y<img.height; ++y) {
    // We get the colour of the pixel in the usual way.
    // Note that the y-coordinate is the value of loop variable y,
    //  and the x-coordinate is that of the current mouse position.
    color p = img.pixels[img.width*y + mouseX];
    // The += operator means add to.
    // The brightness value on the right hand side
    //   is added to the sum on the left hand side.
    sum += brightness(p);
  }
  // The sum is printed.
  println(sum);
}